function varargout = blade_worth_plot(varargin)
%BLADE_WORTH_PLOT M-file for blade_worth_plot.fig
%      BLADE_WORTH_PLOT, by itself, creates a new BLADE_WORTH_PLOT or raises the existing
%      singleton*.
%
%      H = BLADE_WORTH_PLOT returns the handle to a new BLADE_WORTH_PLOT or the handle to
%      the existing singleton*.
%
%      BLADE_WORTH_PLOT('Property','Value',...) creates a new BLADE_WORTH_PLOT using the
%      given property value pairs. Unrecognized properties are passed via
%      varargin to blade_worth_plot_OpeningFcn.  This calling syntax produces a
%      warning when there is an existing singleton*.
%
%      BLADE_WORTH_PLOT('CALLBACK') and BLADE_WORTH_PLOT('CALLBACK',hObject,...) call the
%      local function named CALLBACK in BLADE_WORTH_PLOT.M with the given input
%      arguments.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help blade_worth_plot

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @blade_worth_plot_OpeningFcn, ...
                   'gui_OutputFcn',  @blade_worth_plot_OutputFcn, ...
                   'gui_LayoutFcn',  [], ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
   gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function blade_worth_plot_OpeningFcn(hObject, eventdata, handles, varargin)
handles.output = hObject;
guidata(hObject, handles);

diff_eq_visible();

[imgdata,imgmap] = imread('uml.jpg','jpg');
img = image(imgdata, 'Parent', handles.uml_logo);
set(handles.blade_worth_plot, 'Colormap', imgmap);
set(handles.uml_logo, ...
    'Visible', 'off', ...
    'YDir'   , 'reverse'       , ...
    'XLim'   , get(img,'XData'), ...
    'YLim'   , get(img,'YData')  ...
    );

% --- Outputs from this function are returned to the command line.
function varargout = blade_worth_plot_OutputFcn(hObject, eventdata, handles)
varargout{1} = handles.output;


%% Display/Don't display equations.
function diff_eq_visible()
[imgdata,imgmap] = imread('diff_worth_eqn.jpg','jpg');
img = image(imgdata, 'Parent', findobj('Tag','eqn'));
set(findobj('Tag','blade_worth_plot'), 'Colormap', imgmap);
set(findobj('Tag','eqn'), ...
    'Visible', 'off', ...
    'YDir'   , 'reverse'       , ...
    'XLim'   , get(img,'XData'), ...
    'YLim'   , get(img,'YData')  ...
    );

function integral_eq_visible()
[imgdata,imgmap] = imread('int_worth_eqn.jpg','jpg');
img = image(imgdata, 'Parent', findobj('Tag','eqn'));
set(findobj('Tag','blade_worth_plot'), 'Colormap', imgmap);
set(findobj('Tag','eqn'), ...
    'Visible', 'off', ...
    'YDir'   , 'reverse'       , ...
    'XLim'   , get(img,'XData'), ...
    'YLim'   , get(img,'YData')  ...
    );

%% Reactivity Change
function calc_reactivity_change()
z1 = str2double(get(findobj('Tag','start_position'),'String'));
z2 = str2double(get(findobj('Tag','end_position'),'String'));
if abs(z2-z1) > .01
    c1str = get(findobj('Tag','c1_text'), 'String'); c1 = str2double(c1str(6:length(c1str)));
    c2str = get(findobj('Tag','c2_text'), 'String'); c2 = str2double(c2str(6:length(c2str)));
    c3str = get(findobj('Tag','c3_text'), 'String'); c3 = str2double(c3str(6:length(c3str)));
    c4str = get(findobj('Tag','c4_text'), 'String'); c4 = str2double(c4str(6:length(c4str)));
    c5str = get(findobj('Tag','c5_text'), 'String'); c5 = str2double(c5str(6:length(c5str)));

    rho = @(z) c1*z + (c2*z^2)/2 + (c3*z^3)/3 + (c4*z^4)/4 + (c5*26)/(2*pi)*sin(2*pi*z/26);
    delta_rho = rho(z2) - rho(z1);
    set(findobj('Tag','reactivity_change'),'String',num2str(delta_rho,'%1.3f'));
else
    set(findobj('Tag','reactivity_change'),'String','0');
end;

function draw_reactivity_change()
z1 = str2double(get(findobj('Tag','start_position'),'String'));
z2 = str2double(get(findobj('Tag','end_position'),'String'));

c1str = get(findobj('Tag','c1_text'), 'String'); c1 = str2double(c1str(6:length(c1str)));
c2str = get(findobj('Tag','c2_text'), 'String'); c2 = str2double(c2str(6:length(c2str)));
c3str = get(findobj('Tag','c3_text'), 'String'); c3 = str2double(c3str(6:length(c3str)));
c4str = get(findobj('Tag','c4_text'), 'String'); c4 = str2double(c4str(6:length(c4str)));
c5str = get(findobj('Tag','c5_text'), 'String'); c5 = str2double(c5str(6:length(c5str)));

rho = @(z) c1*z + (c2*z.^2)/2 + (c3*z.^3)/3 + (c4*z.^4)/4 + (c5*26)/(2*pi)*sin(2*pi*z/26);
drho = @(z) c1 + c2*z + c3*z.^2 + c4*z.^3 + c5*cos(2*pi*z/26);

if abs(z2-z1) > .01
if get(findobj('Tag','differential_worth_rb'),'Value')
    x_coords = linspace(z1,z2,100);
    y_coords = drho(x_coords);
    patch([z1 x_coords z2],[0 y_coords 0],[0 1 0],'FaceAlpha',.3,'EdgeColor','none')  
    line(x_coords,y_coords,'Color',[0 .75 0],'LineWidth',2);
    line([z1 z1],[0 drho(z1)],'Color',[0 .75 0],'LineWidth',2);
    line([z2 z2],[0 drho(z2)],'Color',[0 .75 0],'LineWidth',2);
    line([z1 z2],[0 0],'Color',[0 .75 0],'LineWidth',2);
else
    line([z1 z2],[rho(z1) rho(z1)],'LineWidth',2,'LineStyle','--','Color',[0 .75 0]);
    line([z2 z2],[rho(z1) rho(z2)],'LineWidth',2,'LineStyle','--','Color',[0 .75 0]);
end;
end;
%% Callbacks
function total_worth_Callback(hObject, eventdata, handles)

function start_position_Callback(hObject, eventdata, handles)
if str2double(get(hObject,'String')) < 0
    set(hObject,'String','0')
elseif str2double(get(hObject,'String')) > 26
    set(hObject,'String','26')
end;

calc_reactivity_change();
blade_worth_gui('plot_worth');
hold on;
draw_reactivity_change();
hold off;
figure(handles.blade_worth_plot);

function end_position_Callback(hObject, eventdata, handles)
if str2double(get(hObject,'String')) < 0
    set(hObject,'String','0')
elseif str2double(get(hObject,'String')) > 26
    set(hObject,'String','26')
end;

calc_reactivity_change();
blade_worth_gui('plot_worth');
hold on;
draw_reactivity_change();
hold off;
figure(handles.blade_worth_plot);

function reactivity_change_Callback(hObject, eventdata, handles)

function differential_worth_rb_Callback(hObject, eventdata, handles)
set(findobj('Tag','model_type'),'String','Differential Worth Model:');
set(hObject,'Value',1);
set(findobj('Tag','integral_worth_rb'),'Value',0);
diff_eq_visible();
blade_worth_gui('plot_worth');
figure(handles.blade_worth_plot);

function integral_worth_rb_Callback(hObject, eventdata, handles)
set(findobj('Tag','model_type'),'String','Integral Worth Model:');
set(hObject,'Value',1);
set(findobj('Tag','differential_worth_rb'),'Value',0);
integral_eq_visible();
blade_worth_gui('plot_worth');
figure(handles.blade_worth_plot);

function print_menu_item_Callback(hObject, eventdata, handles)
printdlg(handles.blade_worth_plot);

%% Junk functions that we still need to keep.
function total_worth_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function start_position_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function end_position_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function reactivity_change_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


